; 
ODBCConnect proc hDlg :DWORD
;
; In ODBC versions prior to 3.x, you need to call separate functions for
; allocating environment, connection, and statement handles (SQLAllocEnv, SQLAllocConnect, SQLAllocStmt). 
; Now under ODBC 3.x, those functions are superseded by SQLAllocHandle which has the following syntax:
;
    push eax
    mov eax, hConn
    .if eax != 0
    .else
        invoke SQLAllocHandle, SQL_HANDLE_ENV, SQL_NULL_HANDLE, addr hEnv
        .if ax == SQL_SUCCESS
            invoke SQLSetEnvAttr, hEnv, SQL_ATTR_ODBC_VERSION, SQL_OV_ODBC3, 0
            .if ax == SQL_SUCCESS
                invoke SQLAllocHandle, SQL_HANDLE_DBC, hEnv, addr hConn
                .if ax == SQL_SUCCESS
                    invoke lstrcpy, addr ConnectString, addr strConnect   ; "DRIVER={Microsoft Access Driver (*.mdb)};DBQ=", 0
                    invoke lstrcat, addr ConnectString, addr ProgPath     ; inserts drive and path, 0
                    invoke lstrcat, addr ConnectString, addr DBName       ; "test.mdb", 0
                    invoke SQLDriverConnect, hConn, hDlg, addr ConnectString, sizeof ConnectString, addr Conn, sizeof Conn, addr StrLen99, SQL_DRIVER_COMPLETE
                    .if ax == SQL_SUCCESS
                        invoke SwitchMenuState, TRUE
                        invoke MessageBox, hDlg, addr Conn, addr ConnectCaption, MB_OK
                    .else
                        invoke SQLFreeHandle, SQL_HANDLE_DBC, hConn
                        sub eax, eax
                        mov hConn, eax
                        invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
                        sub eax, eax
                        mov hEnv, eax
                        invoke MessageBox, hDlg, addr ConnFail, addr AppName, MB_OK
                    .endif
                .else
                    invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
                    sub eax, eax
                    mov hEnv, eax
                    invoke MessageBox, hDlg, addr AllocConnFail, addr AppName, MB_OK
                .endif
            .else
                invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
                sub eax, eax
                mov hEnv, eax
                invoke MessageBox, hDlg, addr SetAttrFail, addr AppName, MB_OK
            .endif
        .else
            invoke MessageBox, hDlg, addr AllocEnvFail, addr AppName, MB_OK
        .endif
    .endif
    pop eax
    ret
ODBCConnect endp
; 
ODBCDisconnect proc hDlg :DWORD
      push eax
      mov eax, hConn
      .if eax != 0
          invoke SQLDisconnect, hConn
          invoke SQLFreeHandle, SQL_HANDLE_DBC, hConn
          invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
          sub eax, eax
          mov hConn, eax
          mov hEnv, eax
          invoke SwitchMenuState, FALSE
          invoke ShowWindow, hList, SW_HIDE
          invoke MessageBox, hDlg, addr Disconnect, addr AppName, MB_OK
      .endif
      pop eax
	ret
ODBCDisconnect endp
; 
FillData proc
    LOCAL lvi :LV_ITEM
    LOCAL row :DWORD

    invoke SQLSetPos, hStmt, 1, SQL_POSITION, SQL_LOCK_UNLOCK
    invoke SQLSetPos, hStmt, 1, SQL_REFRESH, SQL_LOCK_UNLOCK

;   invoke SQLBindCol, handlestmt, colnumber, targettype, ptrtargetvalue, bufferlength, ptrdatalength
    invoke SQLBindCol, hStmt, 1, SQL_C_CHAR, addr ODBCField01, ODBCField01L, addr ODBCField01L
    invoke SQLBindCol, hStmt, 2, SQL_C_CHAR, addr ODBCField02, ODBCField02L, addr ODBCField02L
    invoke SQLBindCol, hStmt, 3, SQL_C_CHAR, addr ODBCField03, ODBCField03L, addr ODBCField03L
    invoke SQLBindCol, hStmt, 4, SQL_C_CHAR, addr ODBCField04, ODBCField04L, addr ODBCField04L
    invoke SQLBindCol, hStmt, 5, SQL_C_CHAR, addr ODBCField05, ODBCField05L, addr ODBCField05L
    invoke SQLBindCol, hStmt, 6, SQL_C_CHAR, addr ODBCField06, ODBCField06L, addr ODBCField06L
    invoke SendMessage, hList, WM_SETREDRAW, 0, 0   ; stop the updating of the screen area for hList
    mov row, 0
    .while TRUE
           mov byte ptr [ODBCField01], 0 ; We initalize the buffers to zero, incase there is no data selected
           mov byte ptr [ODBCField02], 0 ;    and we still want to process to finish without erroring out
           mov byte ptr [ODBCField03], 0
           mov byte ptr [ODBCField04], 0
           mov byte ptr [ODBCField05], 0
           mov byte ptr [ODBCField06], 0
           invoke SQLFetch, hStmt

; The application can change data values in the rowset buffers.
; To refresh the rowset buffers with data from the cursor library's cache, an application calls
; SQLFetchScroll with the FetchOrientation argument set to SQL_FETCH_RELATIVE and the FetchOffset argument set to 0.

          .if ax == SQL_SUCCESS
               mov lvi.imask, LVIF_TEXT
               push row
               pop lvi.iItem
               mov lvi.iSubItem, 0
               mov lvi.pszText, offset ODBCField01
               invoke SendMessage, hList, LVM_INSERTITEM, 0, addr lvi
                   inc lvi.iSubItem
                   mov lvi.pszText, offset ODBCField02
               invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
                   inc lvi.iSubItem
                   mov lvi.pszText, offset ODBCField03
               invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
                   inc lvi.iSubItem
                   mov lvi.pszText, offset ODBCField04
               invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
                   inc lvi.iSubItem
                   mov lvi.pszText, offset ODBCField05
               invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
                   inc lvi.iSubItem
                   mov lvi.pszText, offset ODBCField06
               invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
               inc lvi.iSubItem
               inc row
           .else
               .break   ; when no more records left, we exit the infinite loop
           .endif
    .endw
    invoke SendMessage, hList, WM_SETREDRAW, 1, 0       ; start the updating of the screen area for hList
    ret
FillData endp
; 
RunQuery proc hDlg :DWORD
    invoke ShowWindow, hList, SW_SHOW
    invoke SendMessage, hList, LVM_DELETEALLITEMS, 0, 0                 ; Data does not refresh after this statement
    invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, addr hStmt
    .if ax == SQL_SUCCESS
        invoke SQLExecDirect, hStmt, addr SQLStatement, sizeof SQLStatement
        .if ax == SQL_SUCCESS
            invoke FillData
        .elseif ax == SQL_ERROR
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr1, addr AppName, MB_OK     ; SQL Error
        .elseif ax == SQL_INVALID_HANDLE
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr2, addr AppName, MB_OK     ; Invalid Handle
        .elseif ax == SQL_NEED_DATA
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr3, addr AppName, MB_OK     ; SQL incomplete
        .elseif ax == SQL_NO_DATA
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr4, addr AppName, MB_OK     ; SQL returned no data
        .elseif ax == SQL_STILL_EXECUTING
            invoke MessageBox, hDlg, addr sqlerr5, addr AppName, MB_OK     ; Still executing SQL stmt
        .else
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr ExecuteFail, addr AppName, MB_OK ; default error message
        .endif

; until the column is unbound by calling SQLBindCol with a null pointer as the variable's address
; SQLFreeStmt with the SQL_UNBIND option

invoke SQLFreeStmt, hStmt, SQL_UNBIND
invoke SQLFreeStmt, hStmt, SQL_CLOSE


        invoke SQLCloseCursor, hStmt
        invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
            sub eax, eax
            mov hStmt, eax
    .else
        invoke ShowWindow, hList, SW_HIDE
        invoke MessageBox, hDlg, addr AllocStmtFail, addr AppName, MB_OK
    .endif
    ret
RunQuery endp
; 
QueryProc proc hDlg :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD	
	.if uMsg == WM_CLOSE
		invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
		invoke EndDialog, hDlg, 0
	.elseif uMsg == WM_INITDIALOG
		invoke ShowWindow, hList, SW_SHOW
		invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, addr hStmt
		.if ax == SQL_SUCCESS || ax == SQL_SUCCESS_WITH_INFO
			invoke lstrcpy, addr Conn, addr SQLStatement
			invoke lstrcat, addr Conn, addr WhereStatement
			invoke SQLBindParameter, hStmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 25, 0, addr SearchName, 25, addr StrLen99
			invoke SQLPrepare, hStmt, addr Conn, sizeof Conn
		.else
			invoke ShowWindow, hList, SW_HIDE
			invoke MessageBox, hDlg, addr AllocStmtFail, addr AppName, MB_OK + MB_ICONERROR
			invoke EndDialog, hDlg,0
		.endif	
	.elseif uMsg == WM_COMMAND
		mov eax, wParam
		shr eax, 16
		.if ax == BN_CLICKED
			mov eax, wParam
			.if ax == IDC_OK
				invoke GetDlgItemText, hDlg, IDC_NAME, addr SearchName, 25
				.if ax == 0
					invoke MessageBox, hDlg, addr NoData, addr AppName, MB_OK + MB_ICONERROR
					invoke GetDlgItem, hDlg, IDC_NAME
					invoke SetFocus, eax
				.else
					invoke lstrlen, addr SearchName
					mov StrLen99, eax
					invoke SendMessage, hList, LVM_DELETEALLITEMS, 0, 0
					invoke SQLExecute, hStmt
					invoke FillData
					invoke SQLCloseCursor, hStmt
				.endif
			.else
				invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
				invoke EndDialog, hDlg, 0
			.endif
		.endif
	.else
		mov eax, FALSE
		ret
	.endif
	mov eax, TRUE
	ret
QueryProc endp
; 
InsertColumn proc
	LOCAL lvc :LV_COLUMN
             mov lvc.lx, 75                            ; column width
             mov lvc.imask, LVCF_TEXT + LVCF_WIDTH     ; LVCF_TEXT requires pszText, LVCF_WIDTH requires lx
      ; ------------------------------------------------------
             mov lvc.iSubItem, 0                                  ; zero-based index
             mov lvc.pszText, offset Heading0                     ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax, SizeOf Heading0                  ; pszText buffer size
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 1, addr lvc    ; adds column to viewlist
      ; ------------------------------------------------------
             mov lvc.lx, 55                                       ; all cols will now have this width
             mov lvc.imask, LVCF_TEXT + LVCF_WIDTH + LVCF_FMT     ; add formating capabillities to cols
             mov lvc.fmt, LVCFMT_RIGHT                            ; the rest of the cols are assigned right justify
      ; ------------------------------------------------------
             mov lvc.iSubItem, 1
             mov lvc.pszText, offset Heading1
             mov lvc.cchTextMax,  SizeOf Heading1
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 2, addr lvc
      ; ------------------------------------------------------
             mov lvc.iSubItem, 2
             mov lvc.pszText, offset Heading2
             mov lvc.cchTextMax,  SizeOf Heading2
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 3, addr lvc
      ; ------------------------------------------------------
             mov lvc.iSubItem, 3
             mov lvc.pszText, offset Heading3
             mov lvc.cchTextMax,  SizeOf Heading3
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 4, addr lvc
      ; ------------------------------------------------------
             mov lvc.iSubItem, 4
             mov lvc.pszText, offset Heading4
             mov lvc.cchTextMax,  SizeOf Heading4
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 5, addr lvc
      ; ------------------------------------------------------
             mov lvc.iSubItem, 5
             mov lvc.pszText, offset Heading5
             mov lvc.cchTextMax,  SizeOf Heading5
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 6, addr lvc
      ; ------------------------------------------------------
	ret
InsertColumn endp
; 
SwitchMenuState proc Flag :DWORD
	.if Flag == TRUE
		invoke EnableMenuItem, hMenu, IDM_CONNECT, MF_GRAYED
		invoke EnableMenuItem, hMenu, IDM_DISCONNECT, MF_ENABLED
		invoke EnableMenuItem, hMenu, IDM_QUERY, MF_ENABLED
		invoke EnableMenuItem, hMenu, IDM_CUSTOMQUERY, MF_ENABLED
	.else
		invoke EnableMenuItem, hMenu, IDM_CONNECT, MF_ENABLED
		invoke EnableMenuItem, hMenu, IDM_DISCONNECT, MF_GRAYED
		invoke EnableMenuItem, hMenu, IDM_QUERY, MF_GRAYED
		invoke EnableMenuItem, hMenu, IDM_CUSTOMQUERY, MF_GRAYED
	.endif
	ret
SwitchMenuState endp
; 
GetProgramPath proc
	invoke GetModuleFileName, NULL, addr ProgPath, sizeof ProgPath
	std
	mov edi, offset ProgPath
	add edi, sizeof ProgPath - 1
	mov al, "\"
	mov ecx, sizeof ProgPath
	repne scasb
	cld
	mov byte ptr [edi + 2], 0
	ret
GetProgramPath endp
; 

;=========================================================================
;  Converts a 32 bit num value to a Dec, Hex, Oct or Bin ascii string.
;=========================================================================
; INVOKE BaseAscii, cnt, addr num, 2, 10, 0, 1, 0
; InPut, OutPut, Length only needed if fill is on, Base, Insert commas, Left fill, Add terminating null
;
BaseAscii PROC InPut :DWORD, OutPut :DWORD, Len :DWORD, Base :DWORD, Comma :DWORD, Fill :DWORD, TermA :DWORD
LOCAL LBuff[32] :BYTE
    pushad
    xor esi, esi
    mov eax, InPut                ; Input
    mov ebx, OutPut
    mov byte ptr [ebx], '0'
    .while (eax)
        xor edx, edx
        div Base                   ; Base 10, 16, 8, 2
        add dl, 30h                ; Convert to dec ASCII
        mov LBuff[esi], dl
        inc esi
    .endw
    xor edi, edi
    mov ecx, esi
    .if Len > ecx  && Fill == 1          ; Zero fill
        xor eax, eax
        .while (eax < Len)
            mov byte ptr [ebx+eax], '0'
            inc eax
        .endw
            sub     Len, ecx
            add     edi, Len
    .endif
    .while (ecx)
        mov al, byte ptr LBuff[esi-1]
        mov byte ptr [ebx+edi], al
        inc edi
        dec esi
        dec ecx
    .endw
    .if TermA                            ; Insert a terminating char
        mov byte ptr [ebx+edi], 0
    .endif
    popad
    ret
BaseAscii ENDP



; 
; -------------------------------- SQLState after SQLAllocHandle stmt
; 01000 General warning
; 08003 Connection does not exist
; HY000 General error
; HY001 Memory allocation error
; HY009 Invalid use of null pointer
; HY010 Function sequence error
; HY013 Memory management error
; HY014 Limit on the number of handles exceeded
; HY092 Invalid attribute/option identifier
; HYC00 Optional feature not implemented
; HYT01 Connection timeout expired
; IM001 Driver does not support this function
; -------------------------------- SQLState after SQLExecDirect stmt
; 01000 General warning
; 01001 Cursor operation conflict
; 01003 NULL value eliminated in set function
; 01004 String data, right truncated
; 01006 Privilege not revoked
; 01007 Privilege not granted
; 01S02 Option value changed
; 01S07 Fractional truncation
; 07002 COUNT field incorrect
; 07006 Restricted data type attribute violation
; 07S01 Invalid use of default parameter
; 08S01 Communication link failure
; 21S01 Insert value list does not match column list
; 21S02 Degree of derived table does not match column list
; 22001 String data, right truncation
; 22002 Indicator variable required but not supplied
; 22003 Numeric value out of range
; 22007 Invalid datetime format
; 22008 Datetime field overflow
; 22012 Division by zero
; 22015 Interval field overflow
; 22018 Invalid character value for cast specification
; 22019 Invalid escape character
; 22025 Invalid escape sequence
; 23000 Integrity constraint violation
; 24000 Invalid cursor state
; 34000 Invalid cursor name
; 3D000 Invalid catalog name
; 3F000 Invalid schema name
; 40001 Serialization failure
; 40003 Statement completion unknown
; 42000 Syntax error or access violation
; 42S01 Base table or view already exists
; 42S02 Base table or view not found
; 42S11 Index already exists
; 42S12 Index not found
; 42S21 Column already exists
; 42S22 Column not found
; 44000 WITH CHECK OPTION violation
; HY000 General error
; HY001 Memory allocation error
; HY008 Operation canceled
; HY009 Invalid use of null pointer
; HY010 Function sequence error
; HY013 Memory management error
; HY090 Invalid string or buffer length
; HY105 Invalid parameter type
; HY109 Invalid cursor position
; HYC00 Optional feature not implemented
; HYT00 Timeout expired
; HYT01 Connection timeout expired
; IM001 Driver does not support this function
; -------------------------------- SQLState after
